SystemOrganization addCategory: #TechnologyTreeOptimizationOfTheCivilizationRevolution!
SystemOrganization addCategory: #'TechnologyTreeOptimizationOfTheCivilizationRevolution-data'!

!ByteString methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:15'!
buildingRealizedWithGame: aCRGame 
	^aCRGame buildingNamed: self! !

!ByteString methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 15:20'!
governmentRealizedWithGame: aCRGame 
	^aCRGame governmentTypeNamed: self! !

!ByteString methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:10'!
harvestRealizedWithGame: aCRGame 
	^aCRGame harvestNamed: self ! !

!ByteString methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:12'!
unitRealizedWithGame: aCRGame 
	^aCRGame unitNamed: self! !

!ByteString methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:06'!
wonderRealizedWithGame: aCRGame 
	^aCRGame wonderNamed: self! !

!Collection methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:38'!
someNameHasString: aString 
	^self anySatisfy: [:each| each someNameHasString: aString ]! !

DependencySorter subclass: #CRTechDependencySorter
	instanceVariableNames: 'techs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRTechDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:50'!
prerequisitesOf: aTech

	^aTech requiredTechs  ! !

!CRTechDependencySorter methodsFor: 'accessing' stamp: 'hjo 9/14/2011 00:49'!
techs
	^ techs! !

!CRTechDependencySorter methodsFor: 'accessing' stamp: 'hjo 9/14/2011 00:49'!
techs: anArray
	techs := anArray! !

TestCase subclass: #CRGameTechSetUpTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:48'!
setUp

	game := CRGame new.! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:49'!
testLevel1

	self assert: (game countOfTechsOfLevel:1) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel10

	self assert: (game countOfTechsOfLevel:10) equals: 2.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel11

	self assert: (game countOfTechsOfLevel:11) equals: 2.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel12

	self assert: (game countOfTechsOfLevel:12) equals: 1.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:51'!
testLevel2

	self assert: (game countOfTechsOfLevel:2) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:52'!
testLevel3

	self assert: (game countOfTechsOfLevel:3) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel4

	self assert: (game countOfTechsOfLevel:4) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel5

	self assert: (game countOfTechsOfLevel:5) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel6

	self assert: (game countOfTechsOfLevel:6) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel7

	self assert: (game countOfTechsOfLevel:7) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel8

	self assert: (game countOfTechsOfLevel:8) equals: 6.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel9

	self assert: (game countOfTechsOfLevel:9) equals: 4.
	! !

TestCase subclass: #CRUseTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRUseTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:45'!
setUp
	super setUp.
	game := CRGame new.! !

!CRUseTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:44'!
testAllOfThoseNameHavingString
	|result|
	result := game allOfThoseNameHavingString: 'Lib'.
	self assert: (result includes: (game techNamed: 'Alphabet')).
	self assert: (result includes: (game buildingNamed: 'Library')).
	self assert: (result includes: (game wonderNamed: 'Great Library')).! !

!CRUseTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:45'!
testDemocracyAndBanking
	self assert: 
		(game unaquiredTechOrderToReachTechsNamed: {'Democracy'. 'Banking'}) asArray
		equals: 
	#('Alphabet' 'Bronze Working' 'Writing' 'Literacy' 'Code of Laws' 'Democracy' 'Currency' 'Banking').
	

! !

!CRUseTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:46'!
testTechAquireTwice
	|techs|
	techs := game unaquiredTechOrderToReachTechsNamed: { 'Feudalism' }.

	self assert: 
		(techs) asArray
		equals: 
	#('Alphabet' 'Pottery' 'Horseback Riding' 'Writing' 'Ceremonial Burial' 'Code of Laws' 'Monarchy' 'Feudalism').
	
	game aquireTechsNamed: techs.
	
	techs := game unaquiredTechOrderToReachTechsNamed: { 'Combustion' }.
	
	self assert: 
		(techs) asArray
		equals: 
	#('Bronze Working' 'Iron Working' 'Masonry' 'Literacy' 'Mathematics' 'Construction' 'Engineering' 'Democracy' 'Invention' 'University' 'Gunpowder' 'Metallurgy' 'Steam Power' 'Combustion').! !

!String methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:39'!
someNameHasString: aString 
	^(self findString: aString) > 0! !

!UndefinedObject methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:05'!
buildingRealizedWithGame: aCRGame 
	^self! !

!UndefinedObject methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:05'!
governmentRealizedWithGame: aCRGame 
	^self! !

!UndefinedObject methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:08'!
harvestRealizedWithGame: aCRGame 
	^self! !

!UndefinedObject methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:39'!
someNameHasString: aString 
	^false! !

!UndefinedObject methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:05'!
unitRealizedWithGame: aCRGame 
	^self! !

!UndefinedObject methodsFor: '*TechnologyTreeOptimizationOfTheCivilizationRevolution' stamp: 'HwaJong 4/28/2013 14:08'!
wonderRealizedWithGame: aCRGame 
	^self! !

Object subclass: #CRBuilding
	uses: HashProofTrait
	instanceVariableNames: 'name feature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution-data'!

CRBuilding class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRBuilding class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:27'!
allBuildings

	|all|
	all := (self class selectors select: [:each| each beginsWith: 'building' ])
		collect: [:sym| self perform: sym  ].
	^all! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:18'!
buildingAqueduct
	^self named: 'Aqueduct' feature: 'Cities grow 50% faster'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 1/21/2013 00:46'!
buildingBank
	^self named: 'Bank'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:14'!
buildingBarracks
	^self named: 'Barracks' feature: 'New units are veterans'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 11:53'!
buildingCourthouse
	^self named: 'Courthouse' feature: 'City radius increased'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 14:21'!
buildingFactory
	^self named: 'Factory'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:17'!
buildingGranary
	^self named: 'Granary' feature: '+2 food from plains'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:17'!
buildingLibrary
	^self named: 'Library' feature: '2x science in city'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:17'!
buildingMarket
	^self named: 'Market' feature: '2x city gold production'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 11:09'!
buildingTemple
	^self named: 'Temple' feature: '+1 happiness per citizen'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:18'!
buildingTradingPost
	^self named: 'Trading Post' feature: '+2 trade from deserts'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:25'!
buildingUniversity
	^self named: 'University' feature: '4x science in the city'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 15:51'!
buildingWall
	^self named: 'Walls' feature: 'Increase city defense and loyalty'! !

!CRBuilding class methodsFor: 'data' stamp: 'HwaJong 4/28/2013 12:17'!
buildingWorkshop
	^self named: 'Workshop' feature: '3x resources from hills'! !

!CRBuilding class methodsFor: 'instance creation' stamp: 'HwaJong 1/20/2013 23:09'!
named: aByteString 
	^self new
		name: aByteString! !

!CRBuilding class methodsFor: 'instance creation' stamp: 'HwaJong 4/28/2013 11:08'!
named: aByteString feature: aString
	^self new
		name: aByteString;
		feature: aString! !

!CRBuilding methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:07'!
feature
	^feature! !

!CRBuilding methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:07'!
feature: anObject 
	feature := anObject! !

!CRBuilding methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:48'!
gettersForEquality
	^#(name)! !

!CRBuilding methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:38'!
name
	^name! !

!CRBuilding methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:09'!
name: aByteString 
	name := aByteString ! !

!CRBuilding methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:41'!
someNameHasString: aString 
	^{name. feature} someNameHasString: aString ! !

Object subclass: #CRGame
	instanceVariableNames: 'techs techsAquired buildings units wonders governmentTypes harvests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:36'!
allOfThoseNameHavingString: aString 
	^(techs, buildings, units, wonders, governmentTypes, harvests) select: [:object| object someNameHasString: aString ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:14'!
aquireTechNamed: aString

	techsAquired add: (self techNamed: aString)! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:55'!
aquireTechOrderToReachTechNamed: aByteString 

	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	techsAquired addAll: ds sortedCollection.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:16'!
aquireTechsNamed: anArray 

	anArray do: [:each| self aquireTechNamed: each ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:38'!
buildingNamed: aByteString 
	^buildings detect: [:each| each name = aByteString ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:55'!
countOfTechsOfLevel: aSmallInteger 

	^(self techsOfLevel: aSmallInteger) size! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:25'!
governmentTypeNamed: aByteString 
	^governmentTypes detect: [:each| each name = aByteString ] ! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:10'!
harvestNamed: aString 
	^harvests detect: [:each| each name = aString ]! !

!CRGame methodsFor: 'initialize-release' stamp: 'hjo 9/14/2011 02:13'!
initialize

	super initialize.
	self initializeTechs.
	techsAquired := Set new.! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 4/28/2013 13:56'!
initializeTechs

	techs := CRTech allTechs.
	buildings := CRBuilding allBuildings.
	units := CRUnit allUnits.
	wonders := CRWonder allWonders.
	harvests := CRHarvest allHarvests.
	governmentTypes := CRGovernmentType allGovernmentTypes.
	self setUpTechRequirements.
	self realizeTechRelations.! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 4/28/2013 13:57'!
realizeTechRelations
	techs do: [:t| t realizeRelationsWithGame: self ]! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 4/28/2013 16:47'!
setUpTech: techName
	(self techNamed: techName)! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 4/28/2013 16:46'!
setUpTech: techName requires: anArray
	(self techNamed: techName)
		requiredTechs: (anArray collect: [ :requiredTechName | self techNamed: requiredTechName ])! !

!CRGame methodsFor: 'initialize-release' stamp: 'HwaJong 4/28/2013 16:45'!
setUpTechRequirements

	self setUpTech: 'Alphabet'.
	self setUpTech: 'Bronze Working'.
	self setUpTech: 'Pottery'.
	self setUpTech: 'Ceremonial Burial' requires: {'Pottery'}.
	self setUpTech: 'Iron Working' requires: {'Bronze Working'}.
	self setUpTech: 'Masonry' requires: {'Pottery'}.
	self setUpTech: 'Writing' requires:  {'Alphabet'}.
	self setUpTech: 'Code of Laws' requires:  {'Alphabet'. 'Writing'}.
	self setUpTech: 'Construction' requires:  {'Iron Working'. 'Masonry'}.
	self setUpTech: 'Irrigation' requires:  {'Pottery'. 'Masonry'}.
	self setUpTech: 'Literacy' requires:  {'Alphabet'. 'Writing'}.
	self setUpTech: 'Mathematics' requires:  {'Masonry'. 'Writing'}.
	self setUpTech: 'Currency' requires:  {'Bronze Working'. 'Code of Laws'}.
	self setUpTech: 'Democracy' requires:  {'Code of Laws'. 'Literacy'}.
	self setUpTech: 'Engineering' requires:  {'Construction'. 'Mathematics'}.
	self setUpTech: 'Monarchy' requires:  {'Code of Laws'. 'Ceremonial Burial'. 'Writing'}.
	self setUpTech: 'Navigation' requires:  {'Writing'. 'Mathematics'}.
	self setUpTech: 'Feudalism' requires:  {'Monarchy'. 'Horseback Riding'}.
	self setUpTech: 'Religion' requires:  {'Monarchy'. 'Ceremonial Burial'}.
	self setUpTech: 'Banking' requires:  {'Currency'. 'Code of Laws'. 'Literacy'}.
	self setUpTech: 'University' requires:  {'Democracy'. 'Mathematics'. 'Literacy'}.
	self setUpTech: 'Invention' requires:  {'Engineering'. 'Literacy'}.
	self setUpTech: 'Gunpowder' requires:  {'Feudalism'. 'Invention'}.
	self setUpTech: 'Metallurgy' requires:  {'University'. 'Engineering'. 'Iron Working'}.
	self setUpTech: 'Printing Press' requires:  {'Religion'. 'University'}.
	self setUpTech: 'Steam Power' requires:  {'Invention'. 'Engineering'. 'Iron Working'}.
	self setUpTech: 'Combustion' requires:  {'Gunpowder'. 'Metallurgy'. 'Steam Power'}.
	self setUpTech: 'Electricity' requires:  {'Metallurgy'. 'Engineering'. 'Steam Power'}.
	self setUpTech: 'Industrialization' requires:  {'Banking'. 'Steam Power'}.
	self setUpTech: 'Railroad' requires:  {'Steam Power'}.
	self setUpTech: 'Steel' requires:  {'Metallurgy'. 'Steam Power'}.
	self setUpTech: 'Communism' requires:  {'Industrialization'. 'University'}.
	self setUpTech: 'Flight' requires:  {'Combustion'. 'Metallurgy'. 'Invention'}.
	self setUpTech: 'Mass Production' requires:  {'Industrialization'. 'Railroad'}.
	self setUpTech: 'The Corporation' requires:  {'Industrialization'. 'Banking'}.
	self setUpTech: 'Atomic Theory' requires:  {'University'. 'Invention'. 'Electricity'}.
	self setUpTech: 'The Automobile' requires:  {'Combustion'. 'Steel'}.
	self setUpTech: 'Electronics' requires:  {'The Corporation'. 'Electricity'}.
	self setUpTech: 'Mass Media' requires:  {'The Corporation'. 'Printing Press'}.
	self setUpTech: 'Advanced Flight' requires:  {'Industrialization'. 'Flight'}.
	self setUpTech: 'Nuclear Power' requires:  {'Mass Production'. 'Atomic Theory'}.
	self setUpTech: 'Networking' requires:  {'Electronics'. 'The Corporation'}.
	self setUpTech: 'Space Flight' requires:  {'Electronics'. 'Advanced Flight'. 'Nuclear Power'}.
	self setUpTech: 'Globalization' requires:  {'Networking'. 'Mass Media'}.
	self setUpTech: 'Superconductor' requires:  {'Space Flight'. 'Mass Production'}.
	self setUpTech: 'Future Technology' requires:  {'Globalization'. 'Superconductor'. 'Advanced Flight'}.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:07'!
techNamed: aByteString 

	^techs detect: [:each| each techName = aByteString ] ifNone: [self error: aByteString , ' not a tech name']! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 19:53'!
techOrderToReachTechNamed: aByteString 

	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	^(ds sortedCollection asSortedCollection: (UnarySortDescriptor ascendingBy: #level)) collect: #techName.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:54'!
techsOfLevel: aSmallInteger 

	^techs select: [:each| each level = aSmallInteger ]  ! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 20:05'!
unaquiredTechOrderToReachTechNamed: aByteString 
	
	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	^((ds sortedCollection asSortedCollection: (UnarySortDescriptor ascendingBy: #level)) copyWithoutAll: techsAquired) collect: #techName.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 21:00'!
unaquiredTechOrderToReachTechsNamed: anArray 
	
	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	anArray do: [:aByteString| ds insert: (self techNamed: aByteString)].
	^((ds sortedCollection asSortedCollection: (UnarySortDescriptor ascendingBy: #level)) copyWithoutAll: techsAquired) collect: #techName.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:37'!
unitNamed: aByteString 

	^units detect: [:each| each name = aByteString ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:26'!
unlockingNamed: aByteString 
	^(buildings, units, wonders, governmentTypes) detect: [:each| each name = aByteString ] ifNone: [self error: aByteString, ' is missing']! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:40'!
wonderNamed: aByteString 
	^wonders detect: [:each| each name = aByteString ] ! !

Object subclass: #CRGovernmentType
	uses: HashProofTrait
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution-data'!

CRGovernmentType class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRGovernmentType class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:26'!
allGovernmentTypes
	^(self class selectors select: [:each| each beginsWith: 'governmentType' ])
		collect: [:sym| self perform: sym  ]! !

!CRGovernmentType class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:35'!
governmentTypeDemocracy
	^self named: 'Democracy' description: 'Science and Gold production will increase by 50%, however people will refuse to allow a declaration of war.'! !

!CRGovernmentType class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:28'!
governmentTypeDespotism
	^self named: 'Despotism' description: 'default'! !

!CRGovernmentType class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:31'!
governmentTypeMonarchy
	^self named: 'Monarchy' description: 'Palace culture bonus will double'! !

!CRGovernmentType class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:29'!
governmentTypeRepublic
	^self named: 'Republic' description: 'Settlers can be built for only one population'! !

!CRGovernmentType class methodsFor: 'instance creation' stamp: 'HwaJong 1/21/2013 00:27'!
named: aByteString description: aString
	^self new
		name: aByteString;
		description: aString! !

!CRGovernmentType class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:23'!
unitSpy
	^self named: 'Spy'! !

!CRGovernmentType methodsFor: 'accessing' stamp: 'HwaJong 1/21/2013 00:28'!
description: aByteString 
	description := aByteString ! !

!CRGovernmentType methodsFor: 'accessing' stamp: 'HwaJong 1/21/2013 00:23'!
name
	^name! !

!CRGovernmentType methodsFor: 'accessing' stamp: 'HwaJong 1/21/2013 00:23'!
name: aByteString 
	name := aByteString! !

!CRGovernmentType methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:41'!
someNameHasString: aString 
	^{name. description} someNameHasString: aString ! !

Object subclass: #CRHarvest
	uses: HashProofTrait
	instanceVariableNames: 'name bonus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution-data'!

CRHarvest class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:56'!
allHarvests

	|insts|
	insts := (self class selectors select: [:each| each beginsWith: 'harvest' ])
		collect: [:sym| self perform: sym  ].
	^insts! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:25'!
harvestAluminum
	^self new
		name: 'Aluminum';
		bonus: '4 extra resources'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:08'!
harvestCattle
	^self new
		name:'Cattle';
		bonus: '3 extra food'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:20'!
harvestCoal
	^self new
		name: 'Coal'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:11'!
harvestDye
	^self new
		name: 'Dye';
		bonus: '3 extra trade'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:31'!
harvestFish
	^self new
		name: 'Fish';
		bonus: '2 extra food'
! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 11:26'!
harvestGame
	^self new
		name: 'Game';
		bonus: '3 extra food'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:11'!
harvestIncense
	^self new
		name: 'Incense'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:33'!
harvestIron
	^self new
		name: 'Iron'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:37'!
harvestMarble
	^self new
		name: 'Marble';
		bonus: '2 extra resources'
! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:13'!
harvestOak
	^self new
		name: 'Oak';
		bonus: '3 extra resource'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:12'!
harvestOil
	^self new
		name: 'Oil';
		bonus: '4 extra resources'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:56'!
harvestOxen
	^self new
		name: 'Oxen'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 11:34'!
harvestSilk
	^self new
		name: 'Silk';
		bonus: '3 extra culture'! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:01'!
harvestSulfur
	^self new
		name: 'Sulfur';
		bonus: '3 extra resources'
! !

!CRHarvest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:53'!
harvestWine
	^self new
		name: 'Wine';
		bonus: '2 extra trade'! !

!CRHarvest methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:14'!
bonus
	^ bonus! !

!CRHarvest methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:14'!
bonus: anObject
	bonus := anObject! !

!CRHarvest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:09'!
harvestRealizedWithGame: aCRGame 
	^self! !

!CRHarvest methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:13'!
name
	^name! !

!CRHarvest methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:14'!
name: aString
	name := aString! !

!CRHarvest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:40'!
someNameHasString: aString 
	^{name. bonus} someNameHasString: aString ! !

Object subclass: #CRTech
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'requiredTechs techName bonus level firstBonus harvest wonder government building unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution-data'!

CRTech class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:19'!
allTechs

	|techs|
	techs := (self class selectors select: [:each| each beginsWith: 'tech' ])
		collect: [:sym| self perform: sym  ].
	^techs! !

!CRTech class methodsFor: 'instance creation' stamp: 'hjo 9/13/2011 23:18'!
newTechName: aByteString level: aSmallInteger

	|instance|
	instance := self new.
	instance techName: aByteString.
	instance level: aSmallInteger.
	^instance! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techAdvancedFlight

	^self newTechName: 'Advanced Flight' level: 9! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:26'!
techAlphabet

	^(self newTechName: 'Alphabet' level: 1)
		building: 'Library';
		wonder: 'Oracle of Delphi'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:27'!
techAtomicTheory

	^(self newTechName: 'Atomic Theory' level: 8)
		wonder: 'Manhattan Project'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:50'!
techBanking

	^(self newTechName: 'Banking' level: 5)
		firstBonus: '100 gold pieces';
		building: 'Bank'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:51'!
techBronzeWorking

	^(self newTechName: 'Bronze Working' level: 1)
		harvest: 'Fish';
		unit: 'Archer';
		building: 'Barracks';
		wonder: 'Colossus of Rhodes'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:04'!
techCeremonialBurial

	^(self newTechName: 'Ceremonial Burial' level: 2)
		harvest: 'Incense';
		building: 'Temple';
		wonder: 'Great Pyramid'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:56'!
techCodeOfLaws

	^(self newTechName: 'Code of Laws' level: 3)
		harvest: 'Cattle';
		building: 'Trading Post';
		government: 'Republic';
		firstBonus: 'Trading Post built in capital city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:12'!
techCombustion

	^(self newTechName: 'Combustion' level: 7)
		unit: 'Tank';
		harvest: 'Oil';
		firstBonus: 'Tank built in capital city'
		! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:41'!
techCommunism

	^self newTechName: 'Communism' level: 8! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:52'!
techConstruction

	^(self newTechName: 'Construction' level: 3)
		harvest: 'Oak';
		building: 'Workshop'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:41'!
techCurrency

	^(self newTechName: 'Currency' level: 4)
		unit: 'Caravan';
		building: 'Market';
		wonder: 'Trade Fair of Troyes'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:49'!
techDemocracy

	^(self newTechName: 'Democracy' level: 4)
		unit: 'Pikemen';
		wonder: 'Magna Carta';
		firstBonus: 'Pikemen built in capital city';
		government: 'Democracy'.! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:17'!
techElectricity

	^(self newTechName: 'Electricity' level: 7)
		unit: 'Submarine';
		firstBonus: 'Submarine built in capital city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techElectronics

	^self newTechName: 'Electronics' level: 9! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:43'!
techEngineering

	^(self newTechName: 'Engineering' level: 4)
		firstBonus: '+1 production in each city';
		building: 'Aqueduct'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:58'!
techFeudalism

	^(self newTechName: 'Feudalism' level: 5)
		unit: 'Knight';
		firstBonus: 'Knights built in capital city';
		harvest: 'Game'
! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:42'!
techFlight

	^self newTechName: 'Flight' level: 8! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:46'!
techFutureTechnology

	^self newTechName: 'Future Technology' level: 12! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techGlobalization

	^self newTechName: 'Globalization' level: 11! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:55'!
techGunpowder

	^(self newTechName: 'Gunpowder' level: 6)
		unit: 'Riflemen';
		harvest: 'Sulfur'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:55'!
techHorsebackRiding

	^(self newTechName: 'Horseback Riding' level: 1)
		unit: 'Horsemen';
		harvest: 'Oxen'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:10'!
techIndustrialization

	^(self newTechName: 'Industrialization' level: 7)
		building: 'Factory';
		firstBonus: '+5 gold in each city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 11:59'!
techInvention

	^(self newTechName: 'Invention' level: 5)
		wonder: 'Leonardo Workshop';
		firstBonus: 'A great Person appears'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:33'!
techIronWorking

	^(self newTechName: 'Iron Working' level: 2)
		unit: 'Legion';
		harvest: 'Iron'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:34'!
techIrrigation

	^self newTechName: 'Irrigation' level: 3! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:58'!
techLiteracy

	^(self newTechName: 'Literacy' level: 3)
		building: 'Courthouse';
		wonder: 'Great Theatre';
		firstBonus: '+1 science in each city';
		harvest: 'Silk'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:56'!
techMasonry

	^(self newTechName: 'Masonry' level: 2)
		harvest: 'Marble';
		building: 'Walls';
		wonder: 'Great Wall';
		firstBonus: 'Walls built in capital city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techMassMedia

	^self newTechName: 'Mass Media' level: 9! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:26'!
techMassProduction

	^(self newTechName: 'Mass Production' level: 8)
		unit: 'Infantry';
		harvest: 'Aluminum';
		firstBonus: 'Infantry built in capital city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:50'!
techMathematics

	^(self newTechName: 'Mathematics' level: 3)
		firstBonus: 'Catapult built in capital city';
		unit: 'Catapult'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 12:20'!
techMetallurgy

	^(self newTechName: 'Metallurgy' level: 6)
		unit: 'Cannon';
		firstBonus: 'Cannon built in capital city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:57'!
techMonarchy

	^(self newTechName: 'Monarchy' level: 4)
		harvest: 'Dye';
		wonder: 'Himeji Samurai Castle';
		government: 'Monarchy';
		firstBonus: 'Great Person'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:36'!
techNavigation

	^self newTechName: 'Navigation' level: 4! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techNetworking

	^self newTechName: 'Networking' level: 10! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techNuclearPower

	^self newTechName: 'Nuclear Power' level: 9! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:50'!
techPottery

	^(self newTechName: 'Pottery' level: 1)
		harvest: 'Wine';
		building: 'Granary';
		wonder: 'Hanging Gardens'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:36'!
techPrintingPress

	^(self newTechName: 'Printing Press' level: 6)
		firstBonus: '+1 Culture in each city';
		wonder: 'Mil-Ind. Complex'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 12:51'!
techRailroad

	^(self newTechName: 'Railroad' level: 7)
		firstBonus: '+2 production in each city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techReligion

	^self newTechName: 'Religion' level: 5! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techSpaceFlight

	^self newTechName: 'Space Flight' level: 10! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 12:23'!
techSteamPower

	^(self newTechName: 'Steam Power' level: 6)
		harvest: 'Coal';
		unit: 'Cruiser';
		firstBonus: 'Cruiser built in capital city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 13:39'!
techSteel

	^(self newTechName: 'Steel' level: 7)
		unit: 'Battleship';
		firstBonus: 'Battleship built in capital city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:46'!
techSuperconductor

	^self newTechName: 'Superconductor' level: 11! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techTheAutomobile

	^self newTechName: 'The Automobile' level: 8! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:54'!
techTheCorporation

	^(self newTechName: 'The Corporation' level: 8)
		harvest: 'Oak';
		firstBonus: '+5 Gold in each city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 12:06'!
techUniversity

	^(self newTechName: 'University' level: 5)
		building: 'University';
		wonder: 'Oxford University';
		firstBonus: '+1 Science in each city'! !

!CRTech class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 16:57'!
techWriting

	^(self newTechName: 'Writing' level: 2)
		unit: 'Spy';
		wonder: 'Great Library';
		firstBonus: 'Spy built in capital city'! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:44'!
allOfThoseNameHavingString: aString 
	^{techName. bonus. firstBonus. harvest. wonder. government. building} allOfThoseNameHavingString: aString
! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
bonus
	^ bonus! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
bonus: anObject
	bonus := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:38'!
building
	^building! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:38'!
building: anObject
	building := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 10:53'!
firstBonus
	^ firstBonus! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 10:53'!
firstBonus: anObject
	firstBonus := anObject! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:17'!
gettersForEquality

	^#(techName)! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 15:12'!
government
	^government! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 15:13'!
government: anObject
	government := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 10:59'!
harvest
	^harvest! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 10:59'!
harvest: anObject
	harvest := anObject! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:55'!
initialize 

	super initialize.
	requiredTechs := {}.! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:51'!
level

	^ level! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:04'!
level: aSmallInteger 

	level := aSmallInteger! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:04'!
realizeRelationsWithGame: aCRGame 
	unit := unit unitRealizedWithGame: aCRGame.
	building := building buildingRealizedWithGame: aCRGame.
	government := government governmentRealizedWithGame: aCRGame.
	wonder := wonder wonderRealizedWithGame: aCRGame.
	harvest := harvest harvestRealizedWithGame: aCRGame.! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
requiredTechs
	^ requiredTechs! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
requiredTechs: anObject
	requiredTechs := anObject! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:37'!
someNameHasString: aString 
	^{techName. bonus. firstBonus. harvest. wonder. government. building} someNameHasString: aString! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
techName
	^ techName! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
techName: anObject
	techName := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:43'!
unit
	^unit! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:43'!
unit: anObject
	unit := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:37'!
wonder
	^wonder! !

!CRTech methodsFor: 'accessing' stamp: 'HwaJong 4/28/2013 11:38'!
wonder: anObject
	wonder := anObject! !

Object subclass: #CRUnit
	uses: HashProofTrait
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution-data'!

CRUnit class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:34'!
allUnits
	|all|
	all := (self class selectors select: [:each| each beginsWith: 'unit' ])
		collect: [:sym| self perform: sym  ].
	^all! !

!CRUnit class methodsFor: 'instance creation' stamp: 'HwaJong 1/20/2013 23:14'!
named: aByteString 
	^self new
		name: aByteString! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:35'!
unitArcher
	^self named: 'Archer'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:15'!
unitBattleship
	^self named: 'Battleship'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:54'!
unitCannon
	^self named: 'Cannon'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:36'!
unitCaravan
	^self named: 'Caravan'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:08'!
unitCatapult
	^self named: 'Catapult'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:19'!
unitCruiser
	^self named: 'Cruiser'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:56'!
unitHorsemen
	^self named: 'Horsemen'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:13'!
unitInfantry
	^self named: 'Infantry'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:16'!
unitKnight
	^self named: 'Knight'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:34'!
unitLegion
	^self named: 'Legion'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:31'!
unitPikemen
	^self named: 'Pikemen'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:55'!
unitRiflemen
	^self named: 'Riflemen'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:05'!
unitSpy
	^self named: 'Spy'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:14'!
unitSubmarine
	^self named: 'Submarine'! !

!CRUnit class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:14'!
unitTank
	^self named: 'Tank'! !

!CRUnit methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:37'!
name
	^name! !

!CRUnit methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:14'!
name: aByteString 
	name := aByteString! !

!CRUnit methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:41'!
someNameHasString: aString 
	^name someNameHasString: aString ! !

Object subclass: #CRWonder
	uses: HashProofTrait
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution-data'!

CRWonder class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:39'!
allWonders
	|all|
	all := (self class selectors select: [:each| each beginsWith: 'wonder' ])
		collect: [:sym| self perform: sym  ].
	^all! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:10'!
named: aByteString 
	^self new
		name: aByteString! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:41'!
wonderColossusOfRhodes
	^self named: 'Colossus of Rhodes'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:05'!
wonderGreatLibrary
	^self named: 'Great Library'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 15:05'!
wonderGreatPyramid
	^self named: 'Great Pyramid'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:16'!
wonderGreatTheatre
	^self named: 'Great Theatre'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:01'!
wonderGreatWall
	^self named: 'Great Wall'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:51'!
wonderHangingGardens
	^self named: 'Hanging Gardens'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:30'!
wonderHimejiSamuraiCastle
	^self named: 'Himeji Samurai Castle'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 01:45'!
wonderLeonardoWorkshop
	^self named: 'Leonardo Workshop'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:31'!
wonderMagnaCarta
	^self named: 'Magna Carta'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:08'!
wonderManhattanProject
	^self named: 'Manhattan Project'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:24'!
wonderMilIndComplex
	^self named: 'Mil-Ind. Complex'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/20/2013 23:52'!
wonderOracleOfDelphi
	^self named: 'Oracle of Delphi'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:54'!
wonderOxfordUniversity
	^self named: 'Oxford University'! !

!CRWonder class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/21/2013 00:37'!
wonderTradeFairOfTroyes
	^self named: 'Trade Fair of Troyes'! !

!CRWonder methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:41'!
name
	^name! !

!CRWonder methodsFor: 'accessing' stamp: 'HwaJong 1/20/2013 23:10'!
name: aByteString 
	name := aByteString ! !

!CRWonder methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/28/2013 14:40'!
someNameHasString: aString 
	^name someNameHasString: aString ! !
